<template>
  <card :title="project === null ? '' : `Проект '${project.name}'`">
    <!-- <template #after-title>
      <prime-button label="Запросить быстрые результаты" @click="getFastResult" />
    </template> -->
    <div class="project-filters">
      <div class="form-field">
        <label for="monthpicker">Месяци и год</label>
        <prime-calendar
          id="monthpicker"
          v-model="date"
          view="month"
          date-format="mm/yy"
          selection-mode="range"
        />
      </div>

      <div class="form-field">
        <label for="competitor-dropdown">Выберите проект или конкурента</label>

        <prime-dropdown
          v-model="competitor"
          label="competitor-dropdown"
          :options="competitors"
          option-label="domain"
          :filter="true"
        />
      </div>

      <div class="form-field">
        <label for="group-multi-select">Выберите группы</label>

        <keyword-group-multi-select
          v-model="keywordGroups"
          label="group-multi-select"
          :groups="keywordGroupsSelected"
        />
      </div>

      <div class="project-filters__filter">
        <prime-button @click="submitFilters">Принять</prime-button>
      </div>
    </div>

    <div>
      <prime-button @click="downloadCsv">Скачать CSV</prime-button>
    </div>

    <div v-if="project !== null">
      <project-info-tops
        v-if="topResultReply !== null"
        ref="project"
        :date="selectedDate"
        :top-results="topResultReply"
      />
    </div>
  </card>
</template>

<script lang="ts">
import { parse } from 'json2csv';
import PrimeButton from 'primevue/button/Button.vue';
import PrimeCalendar from 'primevue/calendar/Calendar.vue';
import PrimeDropdown from 'primevue/dropdown/Dropdown.vue';
import { defineComponent } from 'vue';
import { getTopResultByGroup } from '@/api/handler/keywords';
import { getProject } from '@/api/handler/projects';
import { TopResultArgs, TopResultReplyByGroup } from '@/api/keywords';
import Card from '@/components/Card.vue';
import KeywordGroupMultiSelect from '@/components/KeywordGroupMultiSelect.vue';
import ProjectInfoTops from '@/components/projectViewByGroup/ProjectInfoTopsByGroup.vue';
import { Competitor } from '@/models/competitors';
import { KeywordGroup } from '@/models/keywordGroup';
import { KeywordExtended } from '@/models/keywords';
import { ProjectExtendedWithGroups } from '@/models/projects';

type Type = string | null | (string | null)[];

const parseNumber = (data: Type, defaultValue: number): number => {
  let value = defaultValue;
  if (typeof data === 'string') {
    const parseResult = parseInt(data, 10);
    if (isFinite(parseResult)) {
      value = parseResult;
    }
  }
  return value;
};

const parseNumberPositive = (data: Type, defaultValue: number): number => {
  let value = defaultValue;
  const parseResult = parseNumber(data, defaultValue);
  if (parseResult >= 0) {
    value = parseResult;
  }
  return value;
};

const getNumberOfDaysInMonth = (date: Date): number => {
  const newDate = new Date(date);

  newDate.setDate(1);
  const newDate2 = new Date(newDate);

  newDate2.setMonth(newDate.getMonth() + 1);

  return (newDate2.getTime() - newDate.getTime()) / 1000 / 60 / 60 / 24;
};

function isNotNullArray<T>(arr: (T | null)[]): arr is T[] {
  return arr.every(item => item !== null);
}

interface Data {
  project: ProjectExtendedWithGroups | null;
  keywords: KeywordExtended[];
  topResultReply: TopResultReplyByGroup | null;
  date: (Date | null)[] | null;
  selectedDate: (Date)[];
  competitor: Competitor | null;
  keywordGroups: null | KeywordGroup[];
}

export const randomHexColor = (): string => {
  const MIN = 100;
  const MAX = 200;
  const randomInt = (min: number, max: number): number => Math.floor(min + Math.random() * (max + 1 - min));

  const rgb = Array(3)
    .fill(0)
    .map(() => {
      const value = randomInt(MIN, MAX).toString(16);
      return value.length < 2 ? `0${value}` : value;
    });

  return `#${rgb.join('')}`;
};

export default defineComponent({
  name: 'project-view-by-group',
  components: {
    PrimeButton,
    PrimeCalendar,
    PrimeDropdown,
    Card,
    ProjectInfoTops,
    KeywordGroupMultiSelect,
  },
  data(): Data {
    return {
      project: null,
      keywords: [],
      topResultReply: null,
      date: [new Date(), new Date()],
      selectedDate: [new Date(), new Date()],
      competitor: null,
      keywordGroups: null,
    };
  },
  computed: {
    args(): TopResultArgs | null {
      if (this.date === null || this.project === null) {
        return null;
      }

      const competitorID = this.competitor === null || this.competitor.id === -1 ? null : this.competitor.id;
      const id = this.project.id;

      if (!isNotNullArray(this.date)) {
        return null;
      }

      const startMonth = this.date[0].getMonth() + 1;
      const startYear = this.date[0].getFullYear();
      const endMonth = this.date[1].getMonth() + 1;
      const endYear = this.date[1].getFullYear();

      return {
        startYear,
        startMonth,
        endYear,
        endMonth,
        id,
        competitor: competitorID ?? undefined,
        groups: this.keywordGroups === null ? [] : this.keywordGroups.map(group => group.id),
        keywordsIncluded: [],
        keywordsExcluded: [],
      };
    },
    competitors(): Competitor[] {
      if (this.project === null) {
        return [];
      }
      const competitors: Competitor[] = [
        {
          id: -1,
          domain: this.project.domain,
        },
      ];

      for (const item of this.project.competitors) {
        competitors.push(item);
      }
      return competitors;
    },
    keywordGroupsSelected(): KeywordGroup[] {
      if (this.project === null) {
        return [];
      }

      return this.project.groups.map(group => group);
    },
    numberOfDaysInMonth(): number {
      if (this.selectedDate === null || Array.isArray(this.selectedDate)) {
        return -1;
      }
      return getNumberOfDaysInMonth(this.selectedDate);
    },
    isDateArray(): boolean {
      return Array.isArray(this.selectedDate);
    },
  },
  async mounted() {
    const idStr = this.$route.params.id;

    const id = parseNumberPositive(idStr, 0);
    const res = await getProject({ id });

    if (res.__state === 'success') {
      this.project = res.data;
      this.competitor = {
        id: -1,
        domain: this.project.domain,
      };
    }
    this.submitFilters();
  },
  methods: {
    async downloadCsv() {
      if (this.$refs.project === undefined) {
        return;
      }

      const project: any = this.$refs.project;
      const searchEngines = ['google.com', 'yandex.ru'];
      const tableData = [];
      const fields = project.columns.map((column: any) => column.field);
      for (const searchEngine of searchEngines) {
        tableData.push({ keyword: searchEngine });
        const values = [];
        for (const data of project.tableData[searchEngine]) {
          const newValue: any = {};
          for (const key of fields) {
            newValue[key] = data[key] === undefined || data[key] === '' ? '-' : data[key].toString().replace('.', ',');
          }
          values.push(newValue);
        }
        tableData.push(...values);
      }

      const file = parse(tableData, {
        fields,
        delimiter: ';',
        withBOM: true,
      });

      const link = document.createElement('a');
      const encodedUri = `${encodeURI('data:text/csv;charset=utf-8,')}${encodeURIComponent(file)}`;

      link.href = encodedUri;
      link.download = 'Информация_по_группам';
      link.click();

    },
    async submitFilters() {
      if (this.args === null || this.args.id === -1) {
        return;
      }
      if (Array.isArray(this.date) && isNotNullArray(this.date)) {
        this.selectedDate = [...this.date];
      }
      const res1 = await getTopResultByGroup({ ...this.args });
      if (res1.__state === 'success') {
        this.topResultReply = res1.data;
      }
    },
  },
});
</script>
